/*

Some stuff I need to build a layout engine...

*/

#ifndef _LAYOUT_H
#define _LAYOUT_H

#include <stdlib.h>

#ifndef min
#define min(a,b) ((a)<(b)?(a):(b))
#endif

#ifndef max
#define max(a,b) ((a)>(b)?(a):(b))
#endif

// use macro to make code slightly more readable
#define MVPTR(x) dynamic_cast<MView*>(x)


class minimax	// Order now, by dialing the number on your screen!
{
	public:		BPoint	mini;
				BPoint	maxi;
				float	weight;
				
				minimax(int minx=0,int miny=0,
						int maxx=65536,int maxy=65536,
						float wght=1);
				minimax(BPoint min,BPoint max,float wght=1);
};


class MView
{
	public:		BRect	lastsize;
				minimax	mpm;		// something to store my sizes in

				virtual ~MView();
				virtual	minimax	layoutprefs()=0;
				virtual BRect	layout(BRect rect)=0;
};


typedef struct
{
	MView	*kid;
	int		kidnum;
}  sortstruct;

#define M_POPUP_SELECTED 	(0x01000000)
#define M_CHECKBOX_SELECTED	(0x02000000)
#define M_BUTTON_SELECTED 	(0x03000000)
#define M_RADIO_SELECTED 	(0x04000000)

#define M_PLAYBW_SELECTED 	('yalp')
#define M_PLAYFW_SELECTED 	('play')
#define M_FFWD_SELECTED 	('ffwd')
#define M_REW_SELECTED 		('rewd')
#define M_STOP_SELECTED 	('stop')
#define M_EJECT_SELECTED 	('ejct')

extern rgb_color FILL_COLOR;
extern rgb_color LOW_COLOR;
extern rgb_color HI_COLOR;
extern rgb_color BLACK_COLOR;
#define PARENT_COLOR Parent()->ViewColor()

void setcolorscheme(uchar red, uchar green, uchar blue);
void setcolorscheme(rgb_color cs);

#endif
