
/*

	Sample app containing some "self-layouting" classes.
	Copyright (c) 1996, 1997 Marco Nelissen

*/

#include "VGroup.h"
#include "HGroup.h"
#include "TabGroup.h"
#include "Leaf.h"
#include "MButton.h"
#include "MBorder.h"
#include "MCheckBox.h"
#include "PropGadget.h"
#include "Space.h"
#include "MPopup.h"
#include "MTextView.h"
#include "MStringView.h"
#include "MRadioGroup.h"
#include "MStatusBar.h"
#include "MSeperator.h"
#include "MDragBar.h"
#include "appwin.h"
#include "mydebug.h"

#include "MRew.h"
#include "MPlayBW.h"
#include "MStop.h"
#include "MPlayFW.h"
#include "MFFWD.h"
#include "MEject.h"
#include "MVolume.h"
#include "MTextControl.h"
#include "MOutlineListView.h"

mywin *window;
MView	*topview;
BBitmap *myknob;
MTextView *tv;

MOutlineListView *outlineview;

#include "SliderBits.h"

main()
{	
	myapp *app;
	BRect kr;

	prepstack();
	printf("prepstack done\n");

	app = new myapp("application/x-marcone-layout");

	setcolorscheme(190,190,190);

	kr.Set(0, 0, KNOB_WIDTH-1, KNOB_HEIGHT-1);
	myknob = new BBitmap(kr, B_COLOR_8_BIT);
	myknob->SetBits((char*)knob, myknob->BitsLength(), 0, B_COLOR_8_BIT);

	window=new mywin(BRect(10,20,310,120),"Layout",B_TITLED_WINDOW,
						0);


	topview= new MBorder(M_RAISED_BORDER,3,"outer",
				new TabGroup
				(
					(MView*)"buttons",
					new VGroup
					(
						new HGroup(
							new MButton("MViews"),
							new MButton("are quite"),
							new MButton("flexible"),
							0),
						new HGroup(
							new MButton("biggest and smallest"),
							new MSeperator(),
							new MButton("objects"),
							0),
						new HGroup(
							new MButton("are recognized"),
							new MButton("and set"),
							0),
						new HGroup(
							new MButton("fully"),
							new MButton("automatically (NOT!)"),
							0),
						new HGroup(
							new MRew(NULL),
							new MPlayBW(NULL),
							new MStop(NULL),
							new MPlayFW(NULL),
							new MFFWD(NULL),
							new Space(),
							new MVolume(NULL),
							new Space(),
							new MEject(NULL),
							0),
						0
					),
					(MView*)"other stuff",
					new VGroup
					(
						new HGroup
						(
							new VGroup
							(
								new MButton("bounce"),
								new MButton("stereo",true),
								new MButton("stuff"),
								0
							),
							new MSeperator(),
							new VGroup
							(
								new Space(),
								new MPopup("poplabel","item1","item2","item3","last item",0),
								new MPopup(NULL,"label-less","BMenuFields", "are broken", "in the","Preview Release",0),
								new MPopup("lookahere","short","very long item2",0),
								new Space(),
								new MTextControl("enter your name:","Willy Wonka"),
								0
							),
							0
						),
						new MStatusBar(window),
						new MSeperator(),
						new MStatusBar(window),
						0
					),
					(MView*)"more stuff",
					new VGroup
					(
						new HGroup
						(
							new VGroup
							(
								new MCheckBox("check 1"),
								new MCheckBox("check 2",0,true),
								new MCheckBox("check 3",0,true),
								new MCheckBox("check 4"),
							0
							),
							new TabGroup
							(
								(MView*)"group 1",
								new VGroup
								(
									new MBorder
									(
										M_LABELED_BORDER,11,"pick one",
										new MRadioGroup
										(
											"pick me!",
											"no me!",
											"no way, I was first!",
											0
										)
									),
									new MCheckBox("checkbox"),
									new Space(),
									0
								),
								(MView*)"group 2",
								new VGroup
								(
									new Space(),
									new MPopup("pick one","pick me!","no me!","no way, I was first!",0),
									new Space(),
									0
								),
								(MView*)"group 3",
								new VGroup
								(
									new PropGadget(0.02,.8,0.02,.8,myknob),
									new Space(),
									0
								),
								0
							),
							0
						),
						new MDragBar(minimax(10,10,65536,10)),
						0
					),
					(MView*)"yet more",
					new HGroup
					(
						outlineview=new MOutlineListView(),
						new VGroup
						(
							new HGroup
							(
								new Leaf(),
								new MSeperator(),
								new Leaf(),
								new MSeperator(),
								new Leaf(),
								new MSeperator(),
								new Leaf(),
								0
							),
							new MSeperator(),
							new HGroup
							(
								new Leaf(),
								new MSeperator(),
								new Leaf(),
								new MSeperator(),
								new Leaf(),
								new MSeperator(),
								new Leaf(),
								0
							),
							new MSeperator(),
							new HGroup
							(
								new Leaf(),
								new MSeperator(),
								new Leaf(),
								new MSeperator(),
								new Leaf(),
								new MSeperator(),
								new Leaf(),
								0
							),
							new MSeperator(),
							new HGroup
							(
								new Leaf(),
								new MSeperator(),
								new Leaf(),
								new MSeperator(),
								new Leaf(),
								new MSeperator(),
								new Leaf(),
								0
							),
							0
						),
						0
					),
					0
				)
			);

	BListItem *litem;
	outlineview->AddItem(litem=new BStringItem("MOutlineListView"));
	outlineview->AddUnder(new BStringItem("ofcourse)"),litem);
	outlineview->AddUnder(new BStringItem("(with subitems"),litem);
	outlineview->AddItem(new BStringItem("================="));
	outlineview->AddItem(new BStringItem("BOutlineListView"));
	outlineview->AddItem(new BStringItem("has a small bug in PR:"));
	outlineview->AddItem(new BStringItem("it normally doesn't"));
	outlineview->AddItem(new BStringItem("show navigation highlight"));
	outlineview->AddItem(new BStringItem("MOutlineListView does ;)"));


//	tv->SetText("testing...\nline 2\n\nline 4");


	window->AddChild(dynamic_cast<BView*>(topview));
//	window->SetDiscipline(FALSE);
	window->Lock();
	window->Show();
		long count=countviews(dynamic_cast<BView*>(topview));
		printf("%d views, nested %d levels\n",count&0xffff,count>>16);
//		topview->layoutprefs();
	window->Unlock();

	app->Run();
	delete(app);
	checkstack();
	return(0);
}
